# Selene
[![Travis](https://img.shields.io/travis/sarcasmloading/selene.svg)](https://travis-ci.org/sarcasmloading/selene)
[![Pub](https://img.shields.io/pub/v/selene.svg)](https://pub.dartlang.org/packages/selene)


An unofficial Dart client for the [Discord API](http://discordapp.com).  
* Features:
    * REST and WebSocket APIs loosely coupled, so you can write your own implementation (or use the default)
    * Strongly-typed mapped entities with OOP navigational properties
  
  
* Planned:
    * Sending and receiving voice
    * Automatic WebSocket connection recovering and restarting
    * Sharding support (and autosharding)

## Usage
You can browse the `example` folder for some basic examples. The developer bot instance,
`test/selene_test.dart`, is a comprehensive test of the latest functionality.

## Installation
View the [package listing](https://pub.dartlang.org/packages/selene) for installation instructions.  
You will need Dart SDK 2.0.0-dev.55.0 or above.

## Documentation
Documentation is generated with [dartdoc](https://github.com/dart-lang/dartdoc), simply using the `dartdoc` command with no parameters.  
Hosted documentation is available [here.](https://pub.dartlang.org/documentation/selene/latest/)

## Dependencies
* Core:
    * [w_transport](https://github.com/Workiva/w_transport)
    * [logging](https://github.com/dart-lang/logging)
* Developer:
    * [test](https://github.com/dart-lang/test)
    * [meta](https://github.com/dart-lang/sdk/tree/master/pkg/meta)

## Copyright
Copyright (c) 2018 sarcasmloading under the MIT License. All rights reserved.