part of selene;

/// A guild channel with messaging capability.
class GuildTextChannel extends GuildChannel with TextChannel {
  GuildTextChannel._create(Map<String, dynamic> model, Guild guild,
      Client client) : super._create(model, guild, client) {
    _update(model);
  }


  /// The current topic of this channel.
  String topic;

  /// The date and time the last pinned message was pinned.
  DateTime lastPin;

  @override
  void _update(Map<String, dynamic> model) {
    super._update(model);

    topic = model['topic'] ?? topic;

    if (model['last_pin_timestamp'] != null) {
      lastPin = DateTime.parse(model['last_pin_timestamp']);
    }
  }
}
