part of selene;

/// Represents a Discord voice region.
class VoiceRegion extends StringEntity {
  /// The name of this region.
  String name;

  /// Whether this is a VIP-only server.
  bool isVip;

  /// Whether this is not a VIP-only server.
  bool get isNotVip => !isVip;

  /// Whether this is the server that is closest to the client.
  bool isOptimal;

  /// Whether this is not the server that is closest to the client.
  bool get isNotOptimal => !isOptimal;

  /// Whether this is a deprecated server.
  bool isDeprecated;

  /// Whether this is not a deprecated server.
  bool get isNotDeprecated => !isDeprecated;

  /// Whether this a custom voice server.
  bool isCustom;

  /// Whether this is not a custom voice server.
  bool get isNotCustom => !isCustom;

  VoiceRegion._create(Map<String, dynamic> model, Client client)
      : super(model, client) {
    name = model['name'] ?? name;
    isVip = model['vip'] ?? isVip;
    isOptimal = model['optimal'] ?? isOptimal;
    isDeprecated = model['deprecated'] ?? isDeprecated;
    isCustom = model['custom'] ?? isCustom;
  }
}
