part of selene;

/// An exception thrown when the user is being ratelimited.
class RatelimitedException implements Exception {
  final RequestBucket requestBucket;

  final String method;

  DateTime get resetsAt => requestBucket.resetTime;

  const RatelimitedException(this.requestBucket, this.method);

  String toString() =>
      'RatelimitedException: Ratelimited trying to access ${method} ${requestBucket
          .endpoint.toString()} (resets at ${resetsAt.toIso8601String()})';
}
