part of selene;

/// The default implementation of the Discord REST API.
class _RestApiImpl implements RestApiBase {
  transport.HttpClient client;

  String token;

  String type;

  Uri baseUri = Uri.parse('https://discordapp.com/api/v6');

  _RestApiImpl() {
    client = new transport.HttpClient(transportPlatform: vmTransportPlatform);
  }

  void login(String token, {String type = 'Bot'}) {
    this.token = token;
    this.type = type;
  }

  Future<transport.Response> makeNewRequest(String uriReference, String method,
      [Map<String, dynamic> params, RequestOptions options]) async {
    var requestOptions = options ?? RequestOptions._default;

    var request =
    new transport.JsonRequest(transportPlatform: vmTransportPlatform);
    request.uri = Uri.parse(baseUri.toString() + uriReference);

    if (requestOptions.authorize)
      request.headers['Authorization'] = (type ?? '') + ' ' + (token ?? '');

    request.headers['User-Agent'] =
    'DiscordBot (https://github.com/sarcasmloading/selene, $seleneVersion)';
    if (params != null) request.body = params;

    if (!requestOptions.useBuckets) return await request.send(method);

    var bucket = new RequestBucket.getOrCreate(request.uri, this);
    return await bucket.executeRequest(request, method);
  }
}
