part of selene;

/// General utilities to help with decrypting snowflake entities.
class Snowflake {
  /// The string ID of this snowflake.
  String idString;

  /// The integer ID of this snowflake.
  int id;

  /// The timestamp at which this snowflake was created.
  DateTime timestamp;

  /// The internal worker ID which created this snowflake.
  int workerId;

  /// The internal process ID which created this snowflake.
  int processId;

  /// The ID of this snowflake on the creator process.
  int idOnProcess;

  /// The Discord epoch time.
  static DateTime get discordEpoch => new DateTime.utc(
      2015); // Discord Epoch occurs at the first second of 2015

  factory Snowflake.parseString(String snowflakeRaw) {
    return new Snowflake.parseInt(int.parse(snowflakeRaw));
  }

  Snowflake.parseInt(int snowflakeRaw) {
    timestamp =
        discordEpoch.add(new Duration(milliseconds: (snowflakeRaw >> 22)));
    workerId = ((snowflakeRaw & 0x3E0000) >> 17);
    processId = ((snowflakeRaw & 0x1F000) >> 12);
    idOnProcess = snowflakeRaw & 0xFFF;
    idString = snowflakeRaw.toString();
    id = snowflakeRaw;
  }
}
